#    This file is part of MK.
#
#    MK is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MK is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import os
import string
import copy

from mk import env
from mk import funcs
from mk import factory
from mk import tools
from mk import lang
from mk import nodes
from mk import cache

# mk.funcs aliases
make_match_list = funcs.make_match_list
locate_source = funcs.locate_source
shortname = funcs.shortname
libref = funcs.libref
make_serial = funcs.make_serial
topsort = funcs.topsort
loadfile = funcs.loadfile
subdir = funcs.subdir
subdirs = funcs.subdirs
time = funcs._time
run_processes = funcs.run_processes

# mk.factory aliases
make_phony = factory.make_phony
make_source = factory.make_source
make_sources = factory.make_sources
make_object = factory.make_object
make_objects = factory.make_objects
compile_source = factory.compile_source
compile_sources = factory.compile_sources
make_static_lib = factory.make_static_lib
make_shared_lib = factory.make_shared_lib
make_program = factory.make_program
make_parser = factory.make_parser
depends = factory.depends

# mk.tools aliases.
load_tool = tools.load_tool

# Initialize the bundled tools.
[load_tool (x)
 for x in ['ar', 'cc_ld', 'cc', 'cxx', 'gcc_ld', 'gcc', 'ld', 'bison']]

# Local variables:
# mode: python
# indent-tabs-mode: nil
# arch-tag: 1339afee-6bfe-45cd-bfd4-5588bfc5fcf1
# End:
