#    This file is part of MK.
#
#    MK is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MK is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import re

lang_table = {}

class lang:
    def __init__ (self, name, exp = None):
        self.name = name
        if exp:
            self.rex = re.compile (exp)
        else:
            self.rex = None
        lang_table [name] = self

    def match (self, name):
        if self.rex and self.rex.search (name):
            return True
        else:
            return False

unknown = lang ('Unknown')
c = lang ('C', r'\.c$')
cxx = lang ('C++', r'\.(cxx|cc|cpp|c\+\+|C)$')
java = lang ('Java', r'\.(java|class)$')
fortran = lang ('Fortran', r'\.(f|for|fpp|F)$')
objc = lang ('Objective C', r'\.(m|mi)$')
ada = lang ('Ada', r'\.(ads|adb)$')
pascal = lang ('Pascal', r'\.(p|pas)$')
bison = lang ('Bison/YACC', r'\.y$')

def source_lang (name):
    for nm, lang in lang_table.iteritems ():
        if lang.match (name):
            return lang
    return unknown


# Local variables:
# mode: python
# indent-tabs-mode: nil
# arch-tag: b25d0277-afd9-43de-9282-2c6f341d1b77
# End:
