#    This file is part of MK.
#
#    MK is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MK is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


class autoprop (type):
    def __init__(cls, name, bases, dict):
        super (autoprop, cls).__init__ (name, bases, dict)
        props = {}
        for name in dict.keys ():
            if name.startswith ("_get_") or name.startswith ("_set_"):
                props[name[5:]] = 1
        for name in props.keys():
            fget = getattr (cls, "_get_%s" % name, None)
            fset = getattr (cls, "_set_%s" % name, None)
            setattr (cls, name, property (fget, fset))

# Local variables:
# mode: python
# indent-tabs-mode: nil
# arch-tag: e0375d76-8d99-4cb4-8621-95bf56cfebba
# End:
