#    This file is part of MK.
#
#    MK is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MK is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import re
import os
import os.path

_ex = re.compile (r'^\s*#\s*include\s*(<.*>|".*")\s*$')

# Scan each line in the file F and return a list of all included file
# names.
def _scan (f):
    lst = []
    for ln in f:
        m = _ex.match (ln)
        if m:
            lst.append (m.group(1))
    return lst

# Find a file named NAME in the path INC.
def _find (name, inc):
    if name == os.path.abspath (name) and os.access (name, os.R_OK):
        return name
    for d in inc:
        nm = d + '/' + name
        if os.access (nm, os.R_OK):
            return os.path.abspath (nm)
    return None

# Scan the file PATH for ISO C preprocessor include directives.  Scan
# the included files too, recursively.  Place the set of included
# files in DONE.  The paremeter INC is a list of directories to search
# in.
def autodep (path, inc, done):
    if not os.access (path, os.R_OK):
        return
    pending = _scan (file (path, 'r'))
    for nm in pending:
        if nm [0] == '<':
            nm = _find (nm [1:-1], inc)
        else:
            nm = _find (nm [1:-1], [os.path.dirname (path)] + inc)
        if nm and not done.has_key (nm):
            done [nm] = True
            autodep (nm, inc, done)

# Local variables:
# mode: python
# indent-tabs-mode: nil
# arch-tag: 30657045-0b96-4490-a700-76a31a5cc352
# End:
