#    This file is part of MK.
#
#    MK is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    MK is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Foobar; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import os
import types
import mk
import mk.meta

class bison (object):
    __metaclass__ = mk.meta.autoprop

    def __init__ (self):
        self.bison = 'bison'
        self._prefix = None

    def _set_prefix (self, pfx):
        self._prefix = pfx

    def _get_prefix (self):
        return self._prefix

    def compile (self, target):
        cmd = [self.bison, '-d']
        if self.prefix:
            cmd.extend (['-p', self.prefix])
        cmd.extend (['-o', mk.shortname (target.name),
                     mk.shortname (target.grammar.name)])
        return cmd


def get_class ():
    return bison

# Local variables:
# mode: python
# indent-tabs-mode: nil
# arch-tag: b0c05331-48f6-4b4c-8dfa-6cb41a188d51
# End:
